package PureMessage::WebUI::ExpireSessions;
use strict;
use warnings;
use PureMessage::Version qw/$PREFIX/;
use base 'Exporter';
our @EXPORT_OK = qw/$WEBUI_CACHE_DIR expire_sessions expire_mbox_tmp/;

use CGI::Session::ExpireSessions;

our $WEBUI_CACHE_DIR = "$PREFIX/var/cache/webui";

sub expire_sessions {
    my %opts = (
        temp_dir => "$WEBUI_CACHE_DIR/sessions",
        @_
    );
    my $es = CGI::Session::ExpireSessions->new(%opts);
    $es->expire_file_sessions;
}

sub expire_mbox_tmp {
    my %opts = (
        temp_dir => "$WEBUI_CACHE_DIR/tmp",
        older_than => 600,
        @_,
    );
    print "Looking for mbox temp files in $opts{temp_dir}\n" if $opts{verbose};
    my @tmpfiles = glob("$opts{temp_dir}/*");
    for my $f (@tmpfiles) {
        my $mod_date = (stat($f))[9];
        if ((time() - $mod_date) > $opts{older_than}) {
            unlink $f or warn "Can't unlink mbox tmp file $f: $!";
            print "Deleted $f\n" if $opts{verbose};
        }
        elsif ($opts{verbose}) {
            print "$f not older than $opts{older_than} secs...\n";
        }
    }
}

1;
