package PureMessage::WebUI::I18N::ja;

use strict;
use warnings;
use base qw(PureMessage::WebUI::I18N);
use PureMessage::Version qw($PREFIX);
use Locale::Maketext::Lexicon;

# Load the PO translation file
if (-f (my $po = "$PREFIX/etc/groups/lang/ja.po")) {
    Locale::Maketext::Lexicon->import(
        Gettext => $po,
        _auto   => 1, # use english for missing translations
    );
}
else {
    return 0; # don't support this language
}

# Override to use Japanese images
sub language_tag { 
    return 'ja'; 
}

# Override quant because pluralization of nouns
# in Japanese differs greatly from English.
sub quant {
    my ($self, $number, $singular) = @_;    
    return "$number $singular";
}

1;

