// Functions for message action buttons
//

// called by search action buttons
function take_action(type) {
    // determine which messages are selected
    var msgs = new Array;
    
    // We can no longer rely on there being only message checkboxes
    // so only take actions on messages with checkboxes with a name
    // matching \d+_chk
    var msgs_tmp = document.getElementsByTagName('input');
    for (var j=0; j<msgs_tmp.length; j++){
        var tmp = msgs_tmp[j];
        if(tmp.type == 'checkbox' && tmp.id.match(/\d+_chk/)){
            msgs.push(tmp);
        }
    }

    var checked_msgs = new Array;
    for (var i=0; i<msgs.length; i++) {
        if (msgs[i].checked) {
            checked_msgs.push(msgs[i].name)
            msgs[i].checked = 0;
        }
    }
    document.getElementById('selectall_messages_box').checked = 0;

    var num_selected = checked_msgs.length;
    var selected_msgs = checked_msgs.join();

    // tell user what we are doing
    // if nothing is selected, this will return an error to the user
    update_processing_message(type + '?num=' + num_selected);

    if (num_selected) {
        if (type == 'forward') {
            MM_openBrWindow(
                    '/groups/forward?msg_ids=' + selected_msgs,
                    'msgForward', 
                    'scrollbars=no,resizable=no,statusbar=no,width=430,height=450');
        }
        else {
            // perform the approval action
            var now = new Date();
            var url = '/groups/action/' + type 
                      + '?time=' + now.getTime()
                      + '&msgs=' + selected_msgs;
            Ajax.get(url, update_page);
        }
    }
}

function forward_message(msg_id) {
    MM_openBrWindow(
        '/groups/forward?msg_ids=' + msg_id,
        'msgForward',
        'scrollbars=no,resizable=no,statusbar=no,width=430,height=450');
}

function approve_recipient(msg_id, recip, recip_num) {
    if (msg_id && recip && recip_num) {
        update_processing_message('approve?num=1', 
                                  'msg_status_bar.tmpl');
        // Include timestamp so IE doesn't cache the ajax call
        var now = new Date();
        var url = '/groups/action/approve?msgs=' + msg_id 
                  + '&to=' + recip
                  + '&time=' + now.getTime();
        Ajax.get(url, function (data_str) { update_status_page(data_str, 'approve', msg_id, recip_num) });
    }
}

// only used by message popup delete button
function delete_message() {
    var msg_id = document.getElementById('msg_id').innerHTML;
    update_processing_message('delete?num=1', 
                              'msg_status_bar.tmpl');
    var url = '/groups/action/delete?msgs=' + msg_id;
    Ajax.get(url, function (data_str){ update_status_page(data_str, 'delete', msg_id, null) });
}

// only used by message preview save button
function save_message() {
    var msg_id = document.getElementById('msg_id').innerHTML;
    update_processing_message('save?num=1', 'msg_status_bar.tmpl');
    var now = new Date();
    var url = '/groups/action/save?msgs=' + msg_id + '&time=' + now.getTime();
    Ajax.get(url, function (data_str){ update_status_page(data_str, 'save', msg_id, null) });
}

// Used by search page
function update_page(data_str) {
    // we've got the response, so we're no longer processing...
    document.action_processing = 0;

    var data = JSON.parse(data_str);

    // update the status bar
    Jemplate.process('status_bar.tmpl', data, '#status_bar_wrapper');

    // update the search results
    for (var name in data.status) {
        var url = '/groups/images/icons/' + data.status[name]
                  + '.png';
        var bubble = document.getElementById(name + '_status');
        if (bubble) {
            bubble.src = url;
        }
    }

    // Download saved mbox
    if(data.mbox) {
        var url = '/groups/save?mbox=' + data.mbox;
        document.location = url;
    }
}

// only used by message status popup buttons
function update_status_page(data_str, action, msg_id, recip_num) {
    // we've got the response, so we're no longer processing...
    document.action_processing = 0;

    var data = JSON.parse(data_str);
    Jemplate.process('msg_status_bar.tmpl', data, '#status_bar_wrapper');
    if(action == 'save') {
        // Download saved mbox
        if(data.mbox) {
            var url = '/groups/save?mbox=' + data.mbox;
            document.location = url;
        }
    }
    else {
        var url = '/groups/images/icons/' + data.status[msg_id] + '.png';
        document.getElementById('msg_status_icon').src = url;
        if (recip_num && action == 'approve') {
            if (data.action_success) {
                document.getElementById(recip_num + '_status_icon').src = 
                    '/groups/images/icons/approved.png';
            }
            // XXX It would be better to do this using the DOM
            document.getElementById(recip_num + '_status_desc').innerHTML = data.recip_status;
        }
    }
}

// search page delete all buttons
function delete_all(confirm_str) {
    var where = document.getElementById('where_clause').innerHTML;
    var reason = document.getElementById('search_reason').innerHTML;
    
    // TT2 will put 'undefined' in where_clause if it was not
    // specified.
    if ((!where) || (where == 'undefined')) {
        // no where clause - nothing to delete
        // send localized error message back to status_bar
        update_processing_message('delete_all?where=');
        return;
    }

    if (!confirm(confirm_str)) { return };
    // no where clause - nothing to delete
    // send localized error message back to status_bar
    update_processing_message('delete_all?where=' + where + '&reason=' + reason);

    // perform the approval action
    var url = '/groups/action/delete_all/?where=' + where + '&reason=' + reason;
    var now = new Date();
    url = url + '&time=' + now.getTime();
    Ajax.get(url, update_page);
}

function update_processing_message(action, template) {
    if (!template) template = 'status_bar.tmpl';
    document.action_processing = 1;
    function update_processing_cb(data_str) {
        // avoid a race condition between processing and real request
        if (document.action_processing) {
            var data = JSON.parse(data_str);
            // update the status bar
            Jemplate.process(template, data, '#status_bar_wrapper');
        }
    }
    Ajax.get('/groups/action/processing/' + action, update_processing_cb);
}

// Select box functions
// onchange="selectall_message_boxes(this)"
function selectall_message_boxes (selectall) {
    var nodes = document.getElementsByTagName('input');

    var chk_value = selectall.checked;

    for(var i = 0; i < nodes.length; i++){
        var n = nodes.item(i);
        var cur_id = n.id;
        if(cur_id.match(/\d+_chk/)){
            n.checked = chk_value;
        }
    }

    return true;
}

// Sort the quarantine results
function sort_submit(sort_by, sort_order) {
    var form = document.forms['qsearch_page'];
    form.sort_by.value = sort_by;
    form.sort_order.value = sort_order;
    form.submit();
}
